#!/usr/local/bin/ruby
# (c) 2004 Andreas Krennmair
# $Id: edit.cgi,v 1.9 2004/03/28 17:08:17 ak Exp $

require 'cgi'
require 'cgi/session'
require 'html/template'
require 'entries.rb'
require 'auth.rb'
require 'config.rb'
require 'categories.rb'

$cgi = CGI.new


if not is_authenticated? then
  tmpl = HTML::Template.new("tmpl/autherr.html")
  $cgi.out { tmpl.output }
  Kernel.exit(0)
end

tmpl = HTML::Template.new("tmpl/edit.html")

cm = CategoryManager.new("conf/categories.txt")

action = $cgi['action']

if action == 'add' then
  subject = $cgi['subject']
  body = $cgi['body']
  time = $cgi['time']
  wiki_name = EntryManager.wiki_name(subject)
  filename = time + wiki_name + ".txt"
  entry = Entry.new(filename)
  entry.set_subject(subject)
  entry.set_body(body)
  if $cgi.params['categories'].size < 1 then
    x = [0]
  else
    x = $cgi.params['categories']
  end
  entry.set_categories(x)
  entry.write
  cats = cm.get_categories
  cats.each_index do |i|
    tmpl.node("categories").param({ 'name' => cats[i], 'index' => i, 'checked' => '' })
  end
  tmpl.param({ 'action' => 'add' })
elsif action == 'edit' then
  e = Entry.new($cgi['filename'])
  cats = cm.get_categories
  cats.each_index do |i|
    if e.belongs_to_group(i) then
      checked = 'checked="checked"'
    else
      checked = ''
    end
    tmpl.node("categories").param({ 'name' => cats[i], 'index' => i, 'checked' => checked })
  end
  tmpl.param({ 'action' => 'save', 'subject' => e.get_subject.chomp, 'filename' => $cgi['filename'], 'body' => e.get_body, 'time' => e.get_time })
elsif action == 'save' then
  e = Entry.new($cgi['filename'])
  e.set_subject($cgi['subject'])
  e.set_body($cgi['body'])
  if $cgi.params['categories'].size < 1 then
    x = [0]
  else
    x = $cgi.params['categories']
  end
  e.set_categories(x)
  e.write
  cats = cm.get_categories
  cats.each_index do |i|
    tmpl.node("categories").param({ 'name' => cats[i], 'index' => i, 'checked' => '' })
  end
  tmpl.param({ 'action' => 'add' })
elsif action == 'delete' then
  x = $cgi['filename'].split("/")
  File.unlink($conf['postdir'] + "/" + x[x.size-1])
  $cgi.out('status' => 'REDIRECT','location' => 'edit.cgi') { "" }
  Kernel.exit(0) # don'l let Ruby execute all the other code
else
  cats = cm.get_categories
  cats.each_index do |i|
    tmpl.node("categories").param({ 'name' => cats[i], 'index' => i, 'checked' => '' })
  end
  tmpl.param({ 'action' => 'add' }) # default action
end

em = EntryManager.new("entries")

curtime = Time.now.strftime("%Y%m%d-%H%M%S-")
tmpl.param({ 'title' => $conf['blogtitle'], 'time' => curtime })

entries = em.get_entries[0..$conf['lastposts']-1]


entries.each do |e|
  body = EntryManager.link_wiki_names(e.get_body)
  cats = e.get_categories
  cat_names = []
  cats.each do |c|
    cat_names << cm.get_category(c.to_i)
  end
  categories = cat_names.join(", ")
  tmpl.node("entries").param({ 'subject' => e.get_subject.chomp, 
                               'body' => body, 
                               'entry' => e.get_filename, 
                               'time' => e.get_time, 
                               'wikiname' => EntryManager.wiki_name(e.get_subject.chomp),
                               'categories' => categories
                             })
end

$cgi.out { tmpl.output }
