#!/usr/local/bin/ruby
# (c) 2004 Andreas Krennmair
# $Id: index.cgi,v 1.8 2004/03/28 17:19:44 ak Exp $

require 'cgi'
require 'html/template'
require 'categories.rb'
require 'linklist.rb'
require 'entries.rb'
require 'config.rb'

$cgi = CGI.new
em = EntryManager.new("entries")
cm = CategoryManager.new("conf/categories.txt")

blogroll = LinkListManager.new("conf/blogroll.txt")
links = LinkListManager.new("conf/links.txt")

tmpl = HTML::Template.new("tmpl/blogpage.html")
entries = []
if $cgi['page'] != "" then
  x = $cgi['page'].split("/")
  e = Entry.new(x[x.size-1])
  if e.get_categories!=nil then # kludge
    entries << e
  end
elsif $cgi['wiki'] != "" then
  entries = []
  re = Regexp.new("-" + $cgi['wiki'] + "\.txt$", Regexp::IGNORECASE | Regexp::MULTILINE)
  em.get_entries.each do |e|
    if re.match(e.get_filename) != nil then
      entries << e
    end
  end
elsif $cgi['search'] != "" then
  entries = []
  re = Regexp.new($cgi['search'], Regexp::IGNORECASE | Regexp::MULTILINE)
  em.get_entries.each do |e|
    if re.match(e.get_subject) or re.match(e.get_body) then
      entries << e
    end
  end
elsif $cgi['category'] != "" then
  entries = []
  em.get_entries.each do |e|
    if e.belongs_to_group($cgi['category']) then
      entries << e
    end
  end
elsif $cgi['date'] != "" then
  entries = []
  em.get_entries.each do |e|
    if e.get_yearmonth == $cgi['date'] then
      entries << e
    end
  end
else
  entries = em.get_entries[0..$conf['lastposts']-1]
end

# $stderr.puts "size: #{entries.size}"
entries.each do |e|
  cats = e.get_categories
  cat_names = []
  cats.each do |c|
    cat_names << cm.get_category(c.to_i)
  end
  cat_string = cat_names.join(", ")
  body = EntryManager.link_wiki_names(e.get_body)
  tmpl.node("blogpage").param({ 'subject' => e.get_subject, 
                                'body' => body,
                                'time' => e.get_time, 
                                'categories' => cat_string, 
                                'filename' => e.get_filename, 
                                'wikiname' => EntryManager.wiki_name(e.get_subject) })
end


dates = []
em.get_entries.each do |e|
  dates << e.get_yearmonth
end

dates = dates.sort.uniq.reverse
monthnames = [ "", "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December" ]

dates.each do |d|
  year = d[0..3]
  month = monthnames[d[4..5].to_i]
  tmpl.node("archivelist").param({ 'searchdate' => d, 'searchname' => "#{month} #{year}" })
end

categories = cm.get_categories

categories.each_index do |i|
  tmpl.node("categories").param({ 'catno' => i, 'catname' => categories[i] })
end

tmpl.param({ 'blogtitle' => $conf['blogtitle'] })

blogroll.add_node_to_template(tmpl,"blogroll")
links.add_node_to_template(tmpl,"links")

$cgi.out { tmpl.output }
