#!/usr/local/bin/ruby
# (c) 2004 Andreas Krennmair
# $Id: rss.cgi,v 1.4 2004/03/27 23:47:50 ak Exp $

require 'cgi'
require 'html/template'
require 'entries.rb'
require 'config.rb'

$cgi = CGI.new

em = EntryManager.new("entries")

entries = em.get_entries[0..$conf['lastposts']-1]

tmpl = HTML::Template.new("tmpl/rss.xml")

tmpl.param({ 'blogtitle' => $conf['blogtitle'], 
             'blogurl' => $conf['blogurl'], 
             'description' => $conf['description'], 
             'language' => $conf['language'] })

entries.each do |e|
  tmpl.node("item").param({ 'title' => CGI.escapeHTML(e.get_subject.chomp), 
                            'description' => CGI.escapeHTML(e.get_body.chomp), 
                            'filename' => e.get_filename, 
                            'blogurl' => $conf['blogurl'] })
end

$cgi.out { tmpl.output }
